# Earth

Well, Earth is the [planet](planet.md) we live on. It is the third planet from the [Sun](sun.md) of our Solar system which itself is part of the [Milky Way](milky_way.md) [galaxy](galaxy.md), [Universe](universe.md). So far it is the only known place to have [life](life.md).

Now behold the grand rendering of the Earth map in [ASCII](ascii_art.md) ([equirectangular](equirectangular.md) projection):

```
X      v      v      v      v      v      v      v      v      v      v      v      v      v      v      v      X
                        .-,./"">===-_.----..----..      :     -==- 
                     -=""-,><__-;;;<""._         /      :                     -===-
    ___          .=---""""\/ \/ ><."-, "\      /"       :      .--._     ____   __.-""""------""""---.....-----..
> -=_  """""---""           _.-"   \_/   |  .-" /"\     :  _.''     "..""    """                                <
"" _.'ALASKA               {_   ,".__     ""    '"'   _ : (    _/|                                         _  _.. 
  "-._.--"""-._    CANADA    "--"    "\              / \:  ""./ /                                     _--"","/
   ""          \                     _/_            ",_/:_./\_.'                     ASIA            "--.  \/
>               }                   /_\/               \:EUROPE      __  __                           /\|       <
                \            ""=- __.-"              /"":_-. -._ _, /__\ \ (                       .-" ) >-
                 \__   USA      _/                   """:___"   "  ",     ""                   ,-. \ __//
                    |\      __ /                     /"":   ""._..../                          \  "" \_/
>                    \\_  ."  \|      ATLANTIC      /   :          \\   <'\                     |               <
                        \ \_/| -=-      OCEAN       )   :AFRICA     \\_.-" """\                .'
       PACIFIC           "--._\                     \___:            "/        \ .""\_  <^,..-" __
        OCEAN                 \"""-""-.._               :""\         /          "     | _)      \_\INDONESIA
>.............................|..........",.............:...\......./................_\\_....__/\..,__..........<
                              |   SOUTH    \            :   /      |                 "-._\_  \__/  \  ""-_
                               \ AMERICA   /            :  (       }                     """""===-  """""_
                                \_        |             :   \      \                          __.-""._,"",
>                                 \      /              :   /      / |\                     ," AUSTRALIA  \     <
                                  |     |               :   \     /  \/      INDIAN         ";   __        )
                                  |     /               :    \___/            OCEAN           """  ""-._  / 
                                 /     /                :                                               ""   |\
>                                |    /                 :                                               {)   // <
                                 |   |                  :                                                   ""
                                 \_  \                  :
                                   """                  :
>                                     .,                :                                                       <
                       __....___  _/""  \               :          _____   ___.......___......-------...__
--....-----""""----""""         ""      "-..__    __......--"""""""     """                              .;_..... 
                                              """"      : ANTARCTICA
X      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      ^      X
```

Some [numbers](number.md) about the planet Earth:

- age: 4.54 billion years
- distance from the [Sun](sun.md) (nearest, furthest): 147098450 km, 152097597 km, 
- radius (equator, poles): 6378 km, 6356 km
- mass: 5.9 * 10^24 kg
- acceleration by gravity: 9.8 m/s^2
- axial tilt: 23.4 degrees
- length of day: 24 hours
- length of year: 365.25 days
- land vs water area: 148940000 km^2, 361132000 km^2
- average temperature: 15 C

```
     _---"""---_
   .':. ;::.: -./;.
  /;:;:: ':  .-':::\
.|';:'      ';':;:::|.
|::         .:'::;:::|
|::.         ':;:::::|
'|:;           ':;::|'
  \::          .:::/
   ':_        .:_.'
      """----"""
```

*Earth from space*

Earth is the third planet from the [Sun](sun.md) and the fifth largest in the Solar System, it has an ellipsoid shape. It has formed from space dust nearly 5 billion years ago during the formation of our Solar System. Soon after its formation it was struck by a Mars-sized body, called Theia, which led to the formation of the [Moon](moon.md), Earth's only natural satellite. It's only by [curious](interesting.md) happenstance that the Moon is currently of the same size in the sky as the Sun, allowing perfect eclipses -- nonetheless the Moon is constantly getting further away from us and will be getting visually smaller. Earth has a hot core (inner one having temperature around 5200 degrees Celsius), an atmosphere (78% nitrogen, 20% oxygen) and a magnetic field, its surface is mostly (71%) covered by water. Temperatures on the surface stay between -100 C and 60 C, with average of 15 C. Evidence suggests that [life](life.md) appeared on Earth some 3 and a half billion years ago. Earth's axis of rotation is tilted around 24 degrees, which results in change of seasons as the planet revolves around the Sun. Scientists predict that the Earth will be devoured by the Sun that will expand its radius significantly some 7 and a half billion years from now.

LOL IM slightly drunk a little bit

## See Also

- [Universe](universe.md)
- [history](history.md)
- [stereotypes](stereotype.md)